#! /usr/bin/python

from distutils.core import setup, Extension
from Pyrex.Distutils import build_ext
from os import *
from errno import *

incdirs = []
libdirs = []
libs = []

def progoutput(cmd):
  p = popen(cmd)
  out = p.readline()
  if p.read() != '': raise 'extra junk from %s' % cmd
  p.close()
  return out.rstrip('\n')

def libconfig(lib, ver):
  config = lib + '-config'
  if system('%s --check %s' % (config, ver)):
    raise '%s version %s not found' % (lib, ver)
  version = progoutput('%s --version' % config)
  for i in progoutput('%s --cflags' % config).split():
    if i[:2] == '-I': incdirs.append(i[2:])
    else: raise 'strange cflags item %s' % i
  for i in progoutput('%s --libs' % config).split():
    if i[:2] == '-L': libdirs.append(i[2:])
    elif i[:2] == '-l': libs.append(i[2:])
    else: raise 'strange libs item %s' % i

def uniquify(l):
  u = {}
  o = []
  for i in l:
    if i not in u:
      o.append(i)
      u[i] = 1
  return o

libconfig('mLib', '2.0.3')
libconfig('checkpath', '1.1.0')

chk = Extension('checkpath',
                ['checkpath.pyx'],
                ##extra_compile_args = ['-O0'],
                include_dirs = uniquify(incdirs),
                library_dirs = uniquify(libdirs),
                libraries = uniquify(libs))
setup(name = 'checkpath-python',
      version = '1.1.0',
      description = 'Checking paths for security',
      author = 'Straylight/Edgeware',
      author_email = 'mdw@distorted.org.uk',
      license = 'GNU General Public License',
      ext_modules = [chk],
      cmdclass = {'build_ext': build_ext})
